Unit AS23R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAS10_p;

procedure AS23R(var A :Array of Real; var LU :Array of Real;
                N :Integer; IA :Integer; NDIG :Integer; var D1 :Real;
                var D2 :Real; var IPVT :Array of Integer;
                var EQUIL :Array of Real; var WA :Real;
                var IERR :Integer);

implementation

procedure AS23R(var A :Array of Real; var LU :Array of Real;
                N :Integer; IA :Integer; NDIG :Integer; var D1 :Real;
                var D2 :Real; var IPVT :Array of Integer;
                var EQUIL :Array of Real; var WA :Real;
                var IERR :Integer);
var
IDGT,I,J,JM1,K,IMAX,JP1,IM1 :Integer;
RN,WREL,BIGA,BIG,P,SUM,AI,WI,T,TEST,Q :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
FOUR :Real = 4.0;
SIXTN :Real = 16.0;
SIXTH :Real = 0.0625;
label
_5,_10,_15,_20,_25,_30,_35,_40,_45,_50,_55,_60,_65,_70,_75,_80,_85,
_90,_95,_100,_105,_110,_9000,_9005;
begin
IDGT := NDIG;
IERR := 0;
RN := N;
WREL := ZERO;
D1 := ONE;
D2 := ZERO;
BIGA := ZERO;
for I:=1 to N do
 begin
  BIG := ZERO;
  for J:=1 to N do
   begin
    P := A[(I-1)+(J-1)*IA];
    LU[(I-1)+(J-1)*IA] := P;
    P := Abs(P);
    if ( P > BIG ) 
     then BIG := P;
_5:
   end;
  if ( BIG > BIGA ) 
   then BIGA := BIG;
  if ( BIG = ZERO ) 
   then goto _110;
  EQUIL[I-1] := ONE/BIG;
_10:
 end;
for J:=1 to N do
 begin
  JM1 := J-1;
  if ( JM1 < 1 ) 
   then goto _40;
  for I:=1 to JM1 do
   begin
    SUM := LU[(I-1)+(J-1)*IA];
    IM1 := I-1;
    if ( IDGT = 0 ) 
     then goto _25;
    AI := Abs(SUM);
    WI := ZERO;
    if ( IM1 < 1 ) 
     then goto _20;
    for K:=1 to IM1 do
     begin
      T := LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
      SUM := SUM-T;
      WI := WI+Abs(T);
_15:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_20:
    WI := WI+Abs(SUM);
    if ( AI = ZERO ) 
     then AI := BIGA;
    TEST := WI/AI;
    if ( TEST > WREL ) 
     then WREL := TEST;
    goto _35;
_25:
    if ( IM1 < 1 ) 
     then goto _35;
    for K:=1 to IM1 do
     begin
      SUM := SUM-LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
_30:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_35:
   end;
_40:
  P := ZERO;
  for I:=J to N do
   begin
    SUM := LU[(I-1)+(J-1)*IA];
    if ( IDGT = 0 ) 
     then goto _55;
    AI := Abs(SUM);
    WI := ZERO;
    if ( JM1 < 1 ) 
     then goto _50;
    for K:=1 to JM1 do
     begin
      T := LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
      SUM := SUM-T;
      WI := WI+Abs(T);
_45:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_50:
    WI := WI+Abs(SUM);
    if ( AI = ZERO ) 
     then AI := BIGA;
    TEST := WI/AI;
    if ( TEST > WREL ) 
     then WREL := TEST;
    goto _65;
_55:
    if ( JM1 < 1 ) 
     then goto _65;
    for K:=1 to JM1 do
     begin
      SUM := SUM-LU[(I-1)+(K-1)*IA]*LU[(K-1)+(J-1)*IA];
_60:
     end;
    LU[(I-1)+(J-1)*IA] := SUM;
_65:
    Q := EQUIL[I-1]*Abs(SUM);
    if ( P >= Q ) 
     then goto _70;
    P := Q;
    IMAX := I;
_70:
   end;
  if ( RN+P = RN ) 
   then goto _110;
  if ( J = IMAX ) 
   then goto _80;
  D1 := -D1;
  for K:=1 to N do
   begin
    P := LU[(IMAX-1)+(K-1)*IA];
    LU[(IMAX-1)+(K-1)*IA] := LU[(J-1)+(K-1)*IA];
    LU[(J-1)+(K-1)*IA] := P;
_75:
   end;
  EQUIL[IMAX-1] := EQUIL[J-1];
_80:
  IPVT[J-1] := IMAX;
  D1 := D1*LU[(J-1)+(J-1)*IA];
_85:
  if ( Abs(D1) <= ONE ) 
   then goto _90;
  D1 := D1*SIXTH;
  D2 := D2+FOUR;
  goto _85;
_90:
  if ( Abs(D1) >= SIXTH ) 
   then goto _95;
  D1 := D1*SIXTN;
  D2 := D2-FOUR;
  goto _90;
_95:
  JP1 := J+1;
  if ( JP1 > N ) 
   then goto _105;
  P := LU[(J-1)+(J-1)*IA];
  for I:=JP1 to N do
   begin
    LU[(I-1)+(J-1)*IA] := LU[(I-1)+(J-1)*IA]/P;
_100:
   end;
_105:
 end;
if ( IDGT = 0 ) 
 then goto _9005;
P := 3*N+3;
WA := P*WREL;
if ( WA+Power(10.0,-IDGT) <> WA ) 
 then goto _9005;
IERR := 66;
goto _9000;
_110:
IERR := 65;
D1 := ZERO;
D2 := ZERO;
_9000:
UTAS10(IERR,23);
_9005:
end;

end.
