Unit II20R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, LE03R_p, UTII10_p;

procedure II20R(IP :Integer; IQ :Integer; U :Real; V :Real;
                FUNCT :Func_F1; var A :Array of Real;
                var B :Array of Real; var AL :Array of Real;
                var BE :Array of Real; var RAB :Array of Real;
                var RAB1 :Array of Real; var RAB2 :Array of Real;
                var RAB3 :Array of Real; var RAB4 :Array of Real;
                var IERR :Integer);

implementation

procedure II20R(IP :Integer; IQ :Integer; U :Real; V :Real;
                FUNCT :Func_F1; var A :Array of Real;
                var B :Array of Real; var AL :Array of Real;
                var BE :Array of Real; var RAB :Array of Real;
                var RAB1 :Array of Real; var RAB2 :Array of Real;
                var RAB3 :Array of Real; var RAB4 :Array of Real;
                var IERR :Integer);
var
N,N1,KQ,KP,IPX,JUMP,M,J,I,L,K,JT,MA,MB,JI,IS_,IR,IABC,NUMBER,NN,IQX,
   KZ :Integer;
XY,YY,XA,P,AI,ZXY,Z,Q,SUM,PZ,DUMP,UN,ALP,TAU,ATS,EX,DELTA1,DELTA2,ZZ,
   TOP,BOTTOM,ETA1,ETA2,EPS1,EPS2 :Real;
const
SYS005 :Real = 1.5707963267948966192313216916397;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57,_58,_59,_60,_61,_62,_63,_64,_65,_66,_67,_68,_69,_70,
_71,_72,_73,_74,_75,_76,_77,_78,_79,_80,_81,_82,_83,_84;
begin
IERR := 0;
XA := 1;
N := IP+IQ+1;
N1 := N+1;
KQ := 3;
KP := 3;
if ( IP-1 ) < 0
 then goto _1
 else if ( IP-1 ) > 0
       then goto _2
       else goto _1;
_1:
KP := IP+1;
_2:
if ( IQ-1 ) < 0
 then goto _3
 else if ( IQ-1 ) > 0
       then goto _4
       else goto _3;
_3:
KQ := IQ+1;
_4:
IPX := IP+1;
IQX := IQ+1;
JUMP := 1;
M := 2*N+1;
for J:=1 to M do
 begin
  RAB1[0+(J-1)*3] := Cos(SYS005*(J-1)/N);
  XY := ((V-U)*RAB1[0+(J-1)*3]+U+V)/2.0;
  RAB1[1+(J-1)*3] := FUNCT(XY);
  RAB1[2+(J-1)*3] := XY;
_5:
 end;
YY := 0.0;
J := 2;
while ( J<=M ) do
 begin
  YY := YY+RAB1[1+(J-1)*3];
_6:
  inc(J,2);
 end;
for I:=1 to N do
 begin
  RAB2[0+(I-1)*6] := 1.0;
  RAB2[1+(I-1)*6] := RAB1[0+(2*I-1)*3];
_7:
 end;
RAB2[2+0*6] := 0.0;
for I:=1 to N do
 begin
  RAB2[2+0*6] := RAB2[2+0*6]+RAB1[1+(2*I-1)*3]*RAB2[1+(I-1)*6];
_8:
 end;
L := IP+2*IQ;
for J:=2 to L do
 begin
  for I:=1 to N do
   begin
    XA := RAB2[1+(I-1)*6];
    RAB2[1+(I-1)*6] := 2.0*RAB1[0+(2*I-1)*3]*RAB2[1+(I-1)*6]-RAB2[0+(I-1)*6];
    RAB2[0+(I-1)*6] := XA;
_9:
   end;
  RAB2[2+(J-1)*6] := 0.0;
  for K:=1 to N do
   begin
    RAB2[2+(J-1)*6] := RAB2[2+(J-1)*6]+RAB1[1+(2*K-1)*3]*RAB2[1+(K-1)*6];
_10:
   end;
_11:
 end;
case KQ of
 1: goto _21;
 2: goto _12;
 3: goto _15;
end;
_12:
case KP of
 1: goto _13;
 2: goto _14;
 3: goto _14;
end;
_13:
B[1] := -2.0*RAB2[2+0*6]/(YY+RAB2[2+1*6]);
goto _21;
_14:
B[1] := -2.0*RAB2[2+(IP+1-1)*6]/(RAB2[2+(IP-1)*6]+RAB2[2+(IP+2-1)*6]);
goto _21;
_15:
for I:=1 to IQ do
 begin
  JT := I+IP;
  RAB[I-1] := -RAB2[2+(JT-1)*6]*2.0;
  for J:=1 to IQ do
   begin
    MA := J+I+IP;
    MB := Abs(J-I-IP);
    if ( MB ) < 0
     then goto _16
     else if ( MB ) > 0
           then goto _17
           else goto _16;
_16:
    RAB4[(I-1)+(J-1)*IQ] := RAB2[2+(MA-1)*6]+YY;
    goto _18;
_17:
    RAB4[(I-1)+(J-1)*IQ] := RAB2[2+(MA-1)*6]+RAB2[2+(MB-1)*6];
    goto _18;
_18:
   end;
_19:
 end;
LE03R(RAB4,1,IQ,IQ,RAB,9,B,IERR);
if ( IERR <> 0 ) 
 then goto _82;
for I:=1 to IQ do
 begin
  B[I+0] := RAB[I-1];
_20:
 end;
_21:
B[0] := 1.0;
P := N+0.0;
A[0] := YY;
case KQ of
 1: goto _24;
 2: goto _22;
 3: goto _22;
end;
_22:
for I:=1 to IQ do
 begin
  A[0] := A[0]+B[I+0]*RAB2[2+(I-1)*6];
_23:
 end;
_24:
A[0] := A[0]/P;
case KP of
 1: goto _33;
 2: goto _25;
 3: goto _25;
end;
_25:
for I:=1 to IP do
 begin
  AI := RAB2[2+(I-1)*6]*2.0;
  case KQ of
   1: goto _31;
   2: goto _26;
   3: goto _26;
  end;
_26:
  for J:=1 to IQ do
   begin
    KZ := Abs(J-I);
    if ( KZ ) < 0
     then goto _27
     else if ( KZ ) > 0
           then goto _28
           else goto _27;
_27:
    ZXY := YY;
    goto _29;
_28:
    ZXY := RAB2[2+(KZ-1)*6];
_29:
    JI := J+I;
    AI := AI+B[J+0]*(ZXY+RAB2[2+(JI-1)*6]);
_30:
   end;
_31:
  A[I+0] := AI/P;
_32:
 end;
_33:
case KQ of
 1: goto _41;
 2: goto _34;
 3: goto _34;
end;
_34:
for I:=1 to M do
 begin
  Z := RAB1[0+(I-1)*3];
  ZZ := 2.0*Z;
  P := Z;
  Q := 1.0;
  SUM := 1.0+B[1]*Z;
  case KQ of
   1: goto _37;
   2: goto _37;
   3: goto _35;
  end;
_35:
  for J:=2 to IQ do
   begin
    PZ := P;
    P := ZZ*P-Q;
    Q := PZ;
    SUM := SUM+B[J+0]*P;
_36:
   end;
_37:
  case JUMP of
   1: goto _39;
   2: goto _38;
  end;
_38:
  if ( SUM*DUMP ) < 0
   then goto _42
   else if ( SUM*DUMP ) > 0
         then goto _39
         else goto _42;
_39:
  DUMP := SUM;
  JUMP := 2;
_40:
 end;
_41:
goto _43;
_42:
goto _81;
_43:
XA := 2.0/(V-U);
UN := -(V+U)/(V-U);
case KP of
 1: goto _44;
 2: goto _45;
 3: goto _45;
end;
_44:
AL[0] := A[0];
goto _53;
_45:
AL[0] := A[IP-1]+UN*A[IPX-1];
AL[1] := XA*A[IPX-1];
RAB3[0] := A[IP+0];
RAB3[1] := 0.0;
case KP of
 1: goto _53;
 2: goto _53;
 3: goto _46;
end;
_46:
for IR:=3 to IPX do
 begin
  AL[IR-1] := 0.0;
  RAB3[IR-1] := 0.0;
_47:
 end;
IR := IP-2;
_48:
IS_ := IP-IR+1;
_49:
if ( IS_-2 ) < 0
 then goto _52
 else if ( IS_-2 ) > 0
       then goto _50
       else goto _51;
_50:
ALP := XA*XA*RAB3[IS_-3]+XA*(AL[IS_-2]+2.0*UN*RAB3[IS_-2])+UN*AL[IS_-1]+(UN*
    UN-1.0)*RAB3[IS_-1];
TAU := XA*RAB3[IS_-2]+UN*RAB3[IS_-1]*AL[IS_-1];
AL[IS_-1] := ALP;
RAB3[IS_-1] := TAU;
IS_ := IS_-1;
goto _49;
_51:
ALP := XA*(AL[0]+2.0*UN*RAB3[I-1])+UN*AL[1]+(UN*UN-1.0)*RAB3[1];
TAU := XA*RAB3[0]+UN*RAB3[1]+AL[1];
AL[1] := ALP;
RAB3[1] := TAU;
IS_ := 1;
_52:
ALP := UN*AL[0]+(UN*UN-1.0)*RAB3[0]+A[IR+0];
TAU := UN*RAB3[0]+AL[0];
AL[0] := ALP;
RAB3[0] := TAU;
IR := IR-1;
if ( IR ) < 0
 then goto _53
 else if ( IR ) > 0
       then goto _48
       else goto _48;
_53:
case KQ of
 1: goto _54;
 2: goto _55;
 3: goto _55;
end;
_54:
BE[0] := B[0];
goto _63;
_55:
BE[0] := B[IQ-1]+UN*B[IQ+0];
BE[1] := XA*B[IQX-1];
RAB3[0] := B[IQ+0];
RAB3[1] := 0.0;
case KQ of
 1: goto _63;
 2: goto _63;
 3: goto _56;
end;
_56:
for IR:=3 to IQX do
 begin
  BE[IR-1] := 0.0;
  RAB3[IR-1] := 0.0;
_57:
 end;
IR := IQ-2;
_58:
IS_ := IQ-IR+1;
_59:
if ( IS_-2 ) < 0
 then goto _62
 else if ( IS_-2 ) > 0
       then goto _60
       else goto _61;
_60:
ALP := XA*XA*RAB3[IS_-3]+XA*(BE[IS_-2]+2.0*UN*RAB3[IS_-2])+UN*BE[IS_-1]+(UN*
    UN-1.0)*RAB3[IS_-1];
TAU := XA*RAB3[IS_-2]+UN*RAB3[IS_-1]+BE[IS_-1];
BE[IS_-1] := ALP;
RAB3[IS_-1] := TAU;
IS_ := IS_-1;
goto _59;
_61:
ALP := XA*(BE[0]+2.0*UN*RAB3[0])+UN*BE[1]+(UN*UN-1.0)*RAB3[1];
TAU := XA*RAB3[0]+UN*RAB3[1]+BE[1];
BE[1] := ALP;
RAB3[1] := TAU;
IS_ := 1;
_62:
ALP := UN*BE[0]+(UN*UN-1.0)*RAB3[0]+B[IR+0];
TAU := UN*RAB3[0]+BE[0];
BE[0] := ALP;
RAB3[0] := TAU;
IR := IR-1;
if ( IR ) < 0
 then goto _63
 else if ( IR ) > 0
       then goto _58
       else goto _58;
_63:
for I:=1 to IPX do
 begin
  AL[I-1] := AL[I-1]/BE[0];
_64:
 end;
case KQ of
 1: goto _67;
 2: goto _65;
 3: goto _65;
end;
_65:
for I:=2 to IQX do
 begin
  BE[I-1] := BE[I-1]/BE[0];
_66:
 end;
_67:
BE[0] := 1.0;
for I:=1 to N1 do
 begin
  for IABC:=1 to IPX do
   begin
    RAB3[IABC-1] := A[IABC-1];
_68:
   end;
  IS_ := IP;
  NUMBER := 69;
  case KP of
   1: goto _74;
   2: goto _75;
   3: goto _73;
  end;
_69:
  TOP := ATS;
  for IABC:=1 to IQX do
   begin
    RAB3[IABC-1] := B[IABC-1];
_70:
   end;
  IS_ := IQ;
  NUMBER := 71;
  case KQ of
   1: goto _74;
   2: goto _75;
   3: goto _73;
  end;
_71:
  BOTTOM := ATS;
  RAB2[3+(I-1)*6] := TOP/BOTTOM;
  RAB2[4+(I-1)*6] := RAB2[3+(I-1)*6]-RAB1[1+(2*I-1-1)*3];
  RAB2[5+(I-1)*6] := RAB2[4+(I-1)*6]/RAB1[1+(2*I-1-1)*3];
  goto _76;
_72:
  if ( IS_-2 ) < 0
   then goto _75
   else if ( IS_-2 ) > 0
         then goto _73
         else goto _73;
_73:
  RAB3[IS_-1] := RAB3[IS_-1]+2.0*RAB1[0+(2*I-1-1)*3]*RAB3[IS_+0];
  RAB3[IS_-2] := RAB3[IS_-2]-RAB3[IS_+0];
  IS_ := IS_-1;
  goto _72;
_74:
  RAB3[1] := 0.0;
_75:
  ATS := RAB3[0]+RAB1[0+(2*I-1-1)*3]*RAB3[1];
  if ( NUMBER=69 ) then goto _69 else
  if ( NUMBER=71 ) then goto _71;
_76:
 end;
NN := N;
ETA1 := Abs(RAB2[4+0*6]);
for I:=1 to NN do
 begin
  EX := Abs(RAB2[4+(I+1-1)*6]);
  ETA1 := EMax1(ETA1,EX);
_77:
 end;
ETA2 := Abs(RAB2[5+0*6]);
for I:=1 to NN do
 begin
  EX := Abs(RAB2[5+(I+1-1)*6]);
  ETA2 := EMax1(ETA2,EX);
_78:
 end;
DELTA1 := Abs(RAB2[4+0*6]);
for I:=1 to NN do
 begin
  EX := Abs(RAB2[4+(I+1-1)*6]);
  DELTA1 := EMin1(DELTA1,EX);
_79:
 end;
DELTA2 := Abs(RAB2[5+0*6]);
for I:=1 to NN do
 begin
  EX := Abs(RAB2[5+(I+1-1)*6]);
  DELTA2 := EMin1(DELTA2,EX);
_80:
 end;
EPS1 := ETA1/DELTA1;
EPS2 := ETA2/DELTA2;
RAB2[0+0*6] := ETA1;
RAB2[1+0*6] := ETA2;
RAB2[2+0*6] := EPS1;
RAB2[3+0*6] := EPS2;
goto _84;
_81:
IERR := 65;
goto _83;
_82:
IERR := 66;
_83:
UTII10(IERR,20);
_84:
end;

end.
